#include <string>       // std::string
#include <iostream>     // std::cout
#include <sstream>      // std::stringstream
#include <vector>
#include <string>
#include "Parserv3.h"

using namespace std;

vector<string> tokenize(string ss)
{
	string tempString;
	stringstream lineStream(ss);
	vector<string> output;
	
	while (lineStream >> tempString)
	{
		output.push_back(tempString);
	}
	
	//testing---------------
	cout<<"TokenList: ";
	
	for (int i = 0; i <output.size(); ++i)
	{
		cout<<output[i]<<"  ";
	}
	//----------------------
	
	return output;
}

void displayTokenList(vector<string> input)
{
	cout<<"TokenList: "<<endl;
	for (int i = 0; i < input.size(); ++i)
	{
		cout<<input[i]<<endl;
	}
}

vector<string> showCMD(vector<string> input)
{
	if (input.size() > 3)
	{
		cout<<"Syntax error!"<<endl;
	}
	
	PRelation r(input[0]);
	
	// send show command to DBEngine
	
	return input;
}

vector<string> saveCMD(vector<string> input)
{
	if (input.size() > 3)
	{
		cout<<"Syntax error!"<<endl;
	}
	
	PRelation r(input[0]);
	
	// send save command to DBEngine
	
	return input;
}

vector<string> closeCMD(vector<string> input)
{
	if (input.size() > 3)
	{
		cout<<"Syntax error!"<<endl;
	}
	
	PRelation r(input[0]);
	
	// send close command to DBEngine	
	
	return input;
}

vector<string> openCMD(vector<string> input)
{
	if (input.size() > 2)
	{
		cout<<"Syntax error!"<<endl;
	}
	
	PRelation r(input[0]);
	
	// send open command to DBEngine
	
	return input;
}

vector<string> exitCMD(vector<string> input)
{
	if (input[1] != ";")
	{
		cout<<"ERROR: missing semicolon!"<<endl;
	}
	
	if (input[0] != "EXIT") { cout<<"Wrong function/syntax error!"<<endl;}
	cout<<"Passing command: "<<input[0]<<endl;
	
	return input;
}


vector<string> createCMD(vector<string> input)
{
	//relation name will be the first element of the vector of data returned by this function
	
	if (input[0] == "CREATE" && input[1] == "TABLE")
	{
		input.erase(input.begin());
		input.erase(input.begin());
		
		PRelation r;
		r.setPRelation(input[0]);
		
		input.erase(input.begin());
		
		if(input[0] == "(")
		{			
			input.erase(input.begin());
			
			//vector <PExpression> e1;
			
			vector <PAttribute> a;
			
			while(input[0] != ")")	//inserting all values to relation
			{
				PAttribute temp;
				
				if (input[0] == ",")
				{
					input.erase(input.begin());
				}
				
				temp.setPAttributeName(input[0]);
				
				input.erase(input.begin());
				
				if(input[0] == "INTEGER")
				{
					temp.setPAttributeType(input[0]);
					input.erase(input.begin());
				}
				else
				{
					temp.setPAttributeType(input[0].substr(0,input[0].find("("))); 
					temp.setPAttributeSize(stoi(input[0].substr(input[0].find("("), input[0].find(")"))));
					input.erase(input.begin());	
				}
				
				a.push_back(temp);
			}
			
			vector <PAttribute> apk; //save primary keys temp storage
			
			if(input[0] == "PRIMARY" && input[1] == "KEY")
			{
				input.erase(input.begin());
				input.erase(input.begin());
				
				if(input[0] == "(")
				{
				
					while(input[0] != ")")	//inserting all values to relation
					{
						PAttribute temp;
						
						if (input[0] == ",")
						{
							input.erase(input.begin());
						}
						
						temp.setPAttributeName(input[0]);
						
						apk.push_back(temp);
						
						input.erase(input.begin());
					}
					
					
				
					return input;
				}
			}
		}
			
		else cout<<"Syntax error!"<<endl;
	}
	else cout<<"Syntax error!"<<endl;
	
}

vector<string> insertCMD(vector<string> input)
{
	//relation name will be the first element of the vector of data returned by this function
		
	if (input[0] == "INTO")
	{
		input.erase(input.begin());
		
		PRelation r(input[0]);
		
		input.erase(input.begin());
		
		vector <string> s;
		
		if (input[0] == "VALUES" && input[1] == "FROM")
		{
			input.erase(input.begin());
			input.erase(input.begin());
			
			
			if(input[0] == "(")
			{
				if(input[0].at(0) == '\"')
				{
					s.push_back(input[0].substr(1,input[0].find_last_of("\"")));
				}
				vector <PExpression> e;
				input.erase(input.begin());
				
				while(input[0] != ")")	//inserting all values to relation
				//for (int i = 0; i < 2; ++i)
				{
					if (input[0] == ",") input.erase(input.begin());
					
					e.push_back(input[0]);
					
					input.erase(input.begin());
				}
				
				cout << "Inserting: ";
				while(!e.empty())
				{
					cout << e[0].getPExpression() << " ";
					e.erase(e.begin());
				}
				cout << "into " << r.getName() << ".\n";
				
				return input;
				
			}
			
			else if (input[0] == "RELATION")
			{
				input.erase(input.begin());
				
				PExpression e;
				
				while(input[0] != ";")
				{
					e.setPExpression(e.getPExpression() + input[0]);
				}
				
				cout << "Inserting: " << e.getPExpression() << " into " << r.getName() << ".\n";
				
				return input;
			}
			
			else cout<<"Syntax error!"<<endl;
		}
		
		cout<<"Syntax error!"<<endl;
		
	}
	
	else cout<<"Syntax error!"<<endl;
	
}

vector<string> updateCMD(vector<string> input)
{
	PRelation r(input[0]);
	
	input.erase(input.begin());
	
	if(input[0] == "SET")
	{
		input.erase(input.begin());
		
		//parse out ( and send everything until ) into an Expression vector
		if(input[0] == "(")
		{
			
			vector <PAttribute> a;
			PAttribute temp;
			
			vector <string> s;
			
			//vector <PExpression> e;
			
			input.erase(input.begin());
			
			while(input[0] != ")")
			{
				temp.setPAttributeName(input[0]);
				a.push_back(temp);
				temp.setPAttributeName("~");
				
				input.erase(input.begin());
				
				if(input[0] == "=")
				{
					input.erase(input.begin());
					
					s.push_back(input[0]);
				}
				
				else
				{
					cout<<"Syntax error!"<<endl;
				}
				
				if(input[0] == ",")
				{
					input.erase(input.begin());
				}
			}
		}
		
		if(input[0] == "WHERE")
		{
			if(input[0] == "(")
			{
				//PCondition c;
				
				PComparison c;
				POperand oops1;
				POperand oops2;
				POp op;
				
				while(input[0] != ")")
				{
					oops1.setPOperand(input[0]);
					input.erase(input.begin());
					
					oops2.setPOperand(input[0]);
					input.erase(input.begin());
					
					op.setPOp(input[0]);
					input.erase(input.begin());
					
					c.setPComparison(oops1.getPOperand(), op.getPOp(), oops2.getPOperand());
				}
			}
		}
		
		// send update command to DBEngine
	}
	
	else cout<<"Syntax error!"<<endl;
}

vector<string> deleteCMD(vector<string> input)
{
	if (input[0] == "DELETE" && input[1] == "FROM")
	{
		input.erase(input.begin());
		input.erase(input.begin());
		
		PRelation r(input[0]);
		
		if(input[0] == "WHERE")
		{
			if(input[0] == "(")
			{
				//PCondition c;
				
				PComparison c;
				POperand oops1;
				POperand oops2;
				POp op;
				
				while(input[0] != ")")
				{
					oops1.setPOperand(input[0]);
					input.erase(input.begin());
					
					oops2.setPOperand(input[0]);
					input.erase(input.begin());
					
					op.setPOp(input[0]);
					input.erase(input.begin());
					
					c.setPComparison(oops1.getPOperand(), op.getPOp(), oops2.getPOperand());
				}
			}
		}
		
		// send delete command to DBEngine
	}
	else cout<<"Syntax error!"<<endl;
}

void par_line(vector<string> input)	//calls par_command() or par_query() depending on first item from token list
{
/*
• Match the first item in the token list and determine weather this is a command or a query.
• Call functions par_command() or par_query();
• After either par_command() or par_query() returns, make sure the line ends properly with “;” token
*/
	string tempChar = input.back();
	
	if (tempChar != ";")
	{
		cout<<"ERROR! missing semicolon "<<endl;
	}
	
	else
	{
		if ( input[0] == "INSERT")
		{
			cout<<"\nPassing the following arguments to dbEngine: \nCommand: "<<input[0]<<endl;
			input.erase(input.begin());
			vector<string> insertInput = insertCMD(input);
			cout<<"arguments: "<<endl;
			displayTokenList(insertInput);
			
		}
		
		if ( input[0] == "CREATE")
		{
			cout<<"\nPassing the following arguments to dbEngine: \nCommand: "<<input[0]<<endl;
			input.erase(input.begin());
			
			vector<string> insertInput = createCMD(input);
			cout<<"arguments: "<<endl;
			displayTokenList(insertInput);
			
		}
		
		if ( input[0] == "DELETE")
		{
			cout<<"\nPassing the following arguments to dbEngine: \nCommand: "<<input[0]<<endl;
			input.erase(input.begin());
			
			vector<string> insertInput = deleteCMD(input);
			cout<<"arguments: "<<endl;
			displayTokenList(insertInput);
			
		}
		
		if ( input[0] == "UPDATE")
		{
			cout<<"\nPassing the following arguments to dbEngine: \nCommand: "<<input[0]<<endl;
			input.erase(input.begin());
			
			vector<string> insertInput = updateCMD(input);
			cout<<"arguments: "<<endl;
			displayTokenList(insertInput);
			
		}
			
		if ( input[0] == "SHOW")
		{
			showCMD(input);			
		}
		
		if ( input[0] == "EXIT")
		{
			exitCMD(input);			
		}
		
		if ( input[0] == "OPEN")
		{
			openCMD(input);			
		}
		
		if ( input[0] == "SAVE")
		{
			saveCMD(input);			
		}
		
		if ( input[0] == "CLOSE")
		{
			closeCMD(input);			
		}
	}
}

void parse(string input, DBEngine &engine)
{
	engine.storeCommands(input);
	vector<string> listOfTokens = tokenize(input);
	par_line(listOfTokens);
}
/*
int main () {

	
	string ss = "INSERT INTO animals VALUES FROM  ( Joe , cat , 4 ) ;";
	string ss2 = "SHOW Dogs ;";
	string ss3 = "EXIT ; ";
	
	vector<string> listOfTokens = tokenize(ss);
	vector<string> listOfTokens2 = tokenize(ss2);
	vector<string> listOfTokens3 = tokenize(ss3);
	
	par_line(listOfTokens);
	par_line(listOfTokens2);
	par_line(listOfTokens3);
	
		
}
*/